import type { Plugin as VitePlugin } from 'vite';
import type { AstroConfig, ManifestData } from '../../@types/astro';
import type { AllPagesData } from './types';
import type { LogOptions } from '../logger';
import type { ViteConfigWithSSR } from '../create-vite';
import type { BuildInternals } from '../../core/build/internal.js';
import { RouteCache } from '../render/route-cache.js';
export interface StaticBuildOptions {
    allPages: AllPagesData;
    astroConfig: AstroConfig;
    logging: LogOptions;
    manifest: ManifestData;
    origin: string;
    pageNames: string[];
    routeCache: RouteCache;
    viteConfig: ViteConfigWithSSR;
}
export declare function staticBuild(opts: StaticBuildOptions): Promise<void>;
export declare function vitePluginNewBuild(input: Set<string>, internals: BuildInternals, ext: 'js' | 'mjs'): VitePlugin;
