import type { EndpointHandler } from '../../@types/astro';
import type { AstroGlobalPartial, SSRResult } from '../../@types/astro';
export type { Metadata } from './metadata';
export { createMetadata } from './metadata.js';
export { unescapeHTML } from './escape.js';
export declare class AstroComponent {
    private htmlParts;
    private expressions;
    constructor(htmlParts: TemplateStringsArray, expressions: any[]);
    get [Symbol.toStringTag](): string;
    [Symbol.iterator](): Generator<any, void, unknown>;
}
export declare function render(htmlParts: TemplateStringsArray, ...expressions: any[]): Promise<AstroComponent>;
export interface AstroComponentFactory {
    (result: any, props: any, slots: any): ReturnType<typeof render>;
    isAstroComponentFactory?: boolean;
}
export declare function createComponent(cb: AstroComponentFactory): AstroComponentFactory;
export declare function renderSlot(_result: any, slotted: string, fallback?: any): Promise<any>;
export declare const Fragment: unique symbol;
export declare function renderComponent(result: SSRResult, displayName: string, Component: unknown, _props: Record<string | number, any>, slots?: any): Promise<any>;
export declare function createAstro(filePathname: string, _site: string, projectRootStr: string): AstroGlobalPartial;
export declare function addAttribute(value: any, key: string, shouldEscape?: boolean): any;
export declare function spreadAttributes(values: Record<any, any>, shouldEscape?: boolean): any;
export declare function defineStyleVars(selector: string, vars: Record<any, any>): any;
export declare function defineScriptVars(vars: Record<any, any>): any;
export declare function renderEndpoint(mod: EndpointHandler, params: any): Promise<string>;
export declare function renderToString(result: SSRResult, componentFactory: AstroComponentFactory, props: any, children: any): Promise<string>;
export declare function renderHead(result: SSRResult): Promise<string>;
export declare function renderAstroComponent(component: InstanceType<typeof AstroComponent>): Promise<any>;
export declare function renderHTMLElement(result: SSRResult, constructor: typeof HTMLElement, props: any, slots: any): Promise<any>;
